;
;
; To assemble this example program:
;   ASM32 EXAMPLE.ASM TO EXAMPLE.COM EXAMPLE.LST
;
; The EXAMPLE.LST is optional
;

ASM32 ; optional dummy directive to indicate the assembler


BEGIN 100h ; in order to generate a .COM file

CPU PENTIUM ; assemble instructions upto Pentium (if ommited 386 is default)


;
; Both upper and lower case labels and instructions are allowed and have
; the same meaning.

test=50

   MOV AX,2
   ADD BX,AX
   MOV CX,[100h]
   MOV EDI,BUFFER
   MOV EAX,test
R1:MOV [EDI],EAX
   ADD EDI,4
   CALL L50
   DEC ECX
   JNZ R1
   ; addressing modes examples
   MOV AX,BUFFER ; AX=immediate
   MOV AX,[BUFFER] ; AX=memory
   MOV AX,[BX]
   MOV AX,[BX+10]
   MOV AX,[BX+test/2+10]
   MOV AX,[BX+SI]
   MOV AX,[BX+SI+10]
   MOV AX,[ESI]
   MOV AX,[ESI+10]
   MOV AX,[ESI+ECX]
   MOV AX,[ESI+ECX*4]
   MOV AX,[ESI+ECX*4+1000]
   ;
   ; tiny Machine Code demo program
   MOV AX,B800h ; text mode screen seg
   MOV ES,AX
   MOV DX,"M"
   XOR DI,DI
R2:MOV AX,DX
   STOSW
   XOR DL,0Eh
   INC DH
   MOV CX,BP
R3:NEG AX
   LOOP R3
   IN AL,61h
   SUB BP,B0H
   XOR AL,2
   OUT 61h,AL
   CMP DI,1000h
   JC R2
   INT 20h ; return to DOS


L50:ADD EAX,test/2
    CMP EAX,test & 0
    IF C RET
    MOV EAX,[initial]
    ADD W[initial],test
    RET

 DEVEN
initial:DD 100


BUFFER: